#include <iostream>

using namespace std;

int main()
{
    int n, m;
    cin >> n >> m;
    int prijatelj[n+1], neprijatelj[n+1];
    int koef[n+1];
    int veza[n+1];
    int sreca=0;
    for(int i=1; i<=n; i++)
    {
        cin >> koef[i];
        prijatelj[i]=neprijatelj[i]=0;
        veza[i]=0;
    }
    for(int j=1; j<=m; j++)
    {
        int p,q;
        cin >> p >> q;
        veza[p]++;
        veza[q]++;
        if(abs(koef[p])>abs(koef[q]) && veza[p]>veza[q])
        {
            if(koef[p]>0)
            {
                prijatelj[p]++;
                prijatelj[q]++;
            }
            else
            {
                neprijatelj[p]++;
                neprijatelj[q]++;
            }
        }
        else
        {
            if(koef[q]>0)
            {
                prijatelj[p]++;
                prijatelj[q]++;
            }
            else
            {
                neprijatelj[p]++;
                neprijatelj[q]++;
            }
        }
    }
    for(int i=1; i<=n; i++)
    {
        cout << prijatelj[i] << " " << neprijatelj[i] << endl;
    }
    for(int i=1; i<=n; i++)
    {
        sreca+=((prijatelj[i]-neprijatelj[i])*koef[i]);
    }
    cout << sreca;
}